import { FormKitTypeDefinition } from '@formkit/core';
import type { FormKitInputs } from '@formkit/inputs';
import { casts, createSection, label, outer } from '@formkit/inputs';
import InputTextCmp from 'primevue/inputtext';
import { markRaw } from 'vue';
import { messages } from '../sections/messages';

declare module '@formkit/inputs' {
  // https://formkit.com/essentials/custom-inputs#typescript-support
  interface FormKitInputProps<Props extends FormKitInputs<Props>> {
    PInputText: {
      type: 'PInputText';
    };
  }
}

export const PInputText: FormKitTypeDefinition = {
  type: 'input',
  schema: outer(
    label('$label'),
    // custom_FComponent.schema,
    createSection('input', () => ({
      $cmp: 'InputTextCmp',
      bind: '$attrs',
      props: {
        invalid: '$state.invalid',
        type: '$type',
        disabled: '$disabled',
        name: '$node.name',
        onInput: '$handlers.DOMInput',
        onBlur: '$handlers.blur',
        modelValue: '$_value',
        id: '$id',
        'aria-describedby': '$describedBy',
        'aria-required': '$state.required || undefined',
      },
    }))(),
    messages(),
  ),
  library: {
    // 'FComponent': custom_FComponent.library,
    InputTextCmp: markRaw(InputTextCmp),
  },
  features: [casts],
  // schemaMemoKey: 'g2f31c24kjh',
};
